//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include "MainForm.h"
#include "ResultForm.h"
#include "Serializer.h"
#include "ViewForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//oǂݍ
void TSerializer::ReadMembers(gimite::TGTSNode* node)
{
	GIMITE_MAPROFILED("TSerializer::ReadMembers");

	node->ReadObject("Option", frmMain->DevasApp()->Option());
	node->ReadObject("Backup", frmMain->DevasApp()->Backup());

	AnsiString as;
	frmMain->cmbPath->Items->Clear();
	while (node->Read("PathHistory", as))
		frmMain->cmbPath->Items->Add(as);
	frmMain->cmbFilter->Items->Clear();
	while (node->Read("FilterHistory", as))
		frmMain->cmbFilter->Items->Add(as);
	frmMain->cmbSearched->Items->Clear();
	while (node->Read("SearchedHistory", as))
		frmMain->cmbSearched->Items->Add(as);
	frmResult->cmbReplacing->Items->Clear();
	while (node->Read("ReplacingHistory", as))
		frmResult->cmbReplacing->Items->Add(as);

  int n;
  if (node->Read("MainLeft", n))
    frmMain->Left= n;
  if (node->Read("MainTop", n))
    frmMain->Top= n;
  if (node->Read("ResultLeft", n))
    frmResult->Left= n;
  if (node->Read("ResultTop", n))
    frmResult->Top= n;
  if (node->Read("ResultWidth", n))
    frmResult->Width= n;
  if (node->Read("ResultHeight", n))
    frmResult->Height= n;
  if (node->Read("ViewLeft", n))
    frmView->Left= n;
  if (node->Read("ViewTop", n))
    frmView->Top= n;
  if (node->Read("ViewWidth", n))
    frmView->Width= n;
  if (node->Read("ViewHeight", n))
    frmView->Height= n;

	node->Read("Ver3First", bVer3First_);
}

//---------------------------------------------------------------------------
//o
void TSerializer::WriteMembers(gimite::TGTSNode* node)const
{
	GIMITE_MAPROFILED("TSerializer::WriteMembers");

	node->WriteObject("Option", frmMain->DevasApp()->Option());
	node->WriteObject("Backup", frmMain->DevasApp()->Backup());

	for (int i= 0; i<frmMain->cmbPath->Items->Count; ++i)
		node->Write("PathHistory", frmMain->cmbPath->Items->Strings[i]);
	for (int i= 0; i<frmMain->cmbFilter->Items->Count; ++i)
		node->Write("FilterHistory", frmMain->cmbFilter->Items->Strings[i]);
	for (int i= 0; i<frmMain->cmbSearched->Items->Count; ++i)
		node->Write("SearchedHistory", frmMain->cmbSearched->Items->Strings[i]);
	for (int i= 0; i<frmResult->cmbReplacing->Items->Count; ++i)
		node->Write("ReplacingHistory", frmResult->cmbReplacing->Items->Strings[i]);

  node->Write("MainLeft", frmMain->Left);
  node->Write("MainTop", frmMain->Top);
  node->Write("ResultLeft", frmResult->Left);
  node->Write("ResultTop", frmResult->Top);
  node->Write("ResultWidth", frmResult->Width);
  node->Write("ResultHeight", frmResult->Height);
  node->Write("ViewLeft", frmView->Left);
  node->Write("ViewTop", frmView->Top);
  node->Write("ViewWidth", frmView->Width);
  node->Write("ViewHeight", frmView->Height);

	node->Write("Ver3First", bVer3First_);
}

//---------------------------------------------------------------------------
