//---------------------------------------------------------------------------
#ifndef DevasAppH
#define DevasAppH
//---------------------------------------------------------------------------
#include "PlaceList.h"
#include "Option.h"
#include "FileSet.h"
#include "Backup.h"
//---------------------------------------------------------------------------
//AvP[V
class TDevasApp
{
public:
	typedef std::vector<std::string> TStringVector;
	typedef TAbstractPlaceList::TOnPlaceAdd TOnPlaceAdd;
	typedef TBackup::TOnQueryDelete TOnQueryDeleteBackup;
	typedef TBackup::TOnBackupExceedingUnit TOnBackupExceedingUnit;

  TDevasApp();
	TSearchResult Search(const TStringVector& paths,
  		const TStringVector& ssFilter, const std::string& sSearched);
  	//pathsssFilter𖞂t@CsSearched
	TReplaceResult Replace(const std::string& sReplacing);
  	//sReplacingŒu
  std::string ReplacingStr(int nPlace, const std::string& sReplacing);
  	//ẅʒusReplacingŒu
  void ClearPlaceList(){listPlace_.reset(NULL);}//ʒuXgNA
  const TAbstractPlaceList* PlaceList()const{return listPlace_.get();}
  const TFileSet* FileSet()const{return setFile_.get();}
	void SetOnPlaceAdd(TOnPlaceAdd func){onPlaceAdd_= func;}
	void SetOnReportProcess(TOnReportProcess func){onReportProcess_= func;}
	void SetOnFileError(TOnFileError func){onFileError_= func;}
	void SetOnQueryDeleteBackup(TOnQueryDeleteBackup func)
			{backup_->SetOnQueryDelete(func);}
		//obNAbv폜邩u
	void SetOnBackupExceedingUnit(TOnBackupExceedingUnit func)
			{backup_->SetOnBackupExceedingUnit(func);}
		//P̂ŏ𒴂TCỸobNAbvPʂobNAbv邩
	TOption* Option(){return option_.get();}
	TBackup* Backup(){return backup_.get();}

private:
	std::auto_ptr<TAbstractPlaceList> listPlace_;//ʒuXg
	std::auto_ptr<TFileSet> setFile_;//t@CQ
	std::auto_ptr<TOption> option_;//IvV(UN)
	std::auto_ptr<TBackup> backup_;//obNAbv(UN)
	TOnPlaceAdd onPlaceAdd_;//ʒuǉꂽ
	TOnReportProcess onReportProcess_;//ߒ
	TOnFileError onFileError_;//t@CG[

  void OnPlaceAdd(TAbstractPlace* place);//ʒuǉꂽ
  TAbstractReplacingPattern* NewReplacingPattern
	  	(const std::string& sReplacing);
  	//w̒u̒up^[

};

//---------------------------------------------------------------------------
#endif
