//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include "FileErrorDialogForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmFileErrorDialog *frmFileErrorDialog;
//---------------------------------------------------------------------------
__fastcall TfrmFileErrorDialog::TfrmFileErrorDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
TModalResult TfrmFileErrorDialog::ShowMessage(const std::string& message,
  bool bForceEnabled/*= true*/)
{
	auto_ptr<TfrmFileErrorDialog> frm(new TfrmFileErrorDialog(NULL));
	frm->lblMessage->Caption= message.c_str();
  frm->btnForce->Visible= bForceEnabled;
  frm->btnRetry->Visible= !bForceEnabled;
	MessageBeep(MB_ICONEXCLAMATION);
	return frm->ShowModal();
}

//---------------------------------------------------------------------------
